# t00055 - Test case for `row` and `column` layout hints
## Config
```yaml
compilation_database_dir: ..
output_directory: diagrams
diagrams:
  t00055_class:
    type: class
    glob:
      - ../../tests/t00055/t00055.cc
    include:
      namespaces:
        - clanguml::t00055
    using_namespace:
      - clanguml::t00055
    layout:
      A:
        - row: [C, E, G, I]
      B:
        - column: [D, F, H, J]
```
## Source code
File t00055.cc
```cpp
namespace clanguml {
namespace t00055 {
struct A { };
struct B { };
struct C { };
struct D { };
struct E { };
struct F { };
struct G { };
struct H { };
struct I { };
struct J { };
}
}
```
## Generated PlantUML diagrams
![t00055_class](./t00055_class.svg "Test case for `row` and `column` layout hints")
## Generated Mermaid diagrams
![t00055_class](./t00055_class_mermaid.svg "Test case for `row` and `column` layout hints")
## Generated JSON models
```json
{
  "diagram_type": "class",
  "elements": [
    {
      "bases": [],
      "display_name": "clanguml::t00055::A",
      "id": "1697191682863715554",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "A",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 3,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    },
    {
      "bases": [],
      "display_name": "clanguml::t00055::B",
      "id": "188599859894721517",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "B",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 4,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    },
    {
      "bases": [],
      "display_name": "clanguml::t00055::C",
      "id": "625177137967392996",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "C",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 5,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    },
    {
      "bases": [],
      "display_name": "clanguml::t00055::D",
      "id": "1046415640323289221",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "D",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 6,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    },
    {
      "bases": [],
      "display_name": "clanguml::t00055::E",
      "id": "702117239243796422",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "E",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 7,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    },
    {
      "bases": [],
      "display_name": "clanguml::t00055::F",
      "id": "1511375015718046137",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "F",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 8,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    },
    {
      "bases": [],
      "display_name": "clanguml::t00055::G",
      "id": "651600874645139639",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "G",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 9,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    },
    {
      "bases": [],
      "display_name": "clanguml::t00055::H",
      "id": "374142601071476038",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "H",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 10,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    },
    {
      "bases": [],
      "display_name": "clanguml::t00055::I",
      "id": "295372236079742697",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "I",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 11,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    },
    {
      "bases": [],
      "display_name": "clanguml::t00055::J",
      "id": "769231292718551090",
      "is_abstract": false,
      "is_nested": false,
      "is_struct": true,
      "is_template": false,
      "is_union": false,
      "members": [],
      "methods": [],
      "name": "J",
      "namespace": "clanguml::t00055",
      "source_location": {
        "column": 8,
        "file": "../../tests/t00055/t00055.cc",
        "line": 12,
        "translation_unit": "../../tests/t00055/t00055.cc"
      },
      "template_parameters": [],
      "type": "class"
    }
  ],
  "metadata": {
    "clang_uml_version": "0.4.1-11-g39d3e1f",
    "llvm_version": "Ubuntu clang version 16.0.6 (++20230710042027+7cbf1a259152-1~exp1~20230710162048.105)",
    "schema_version": 1
  },
  "name": "t00055_class",
  "relationships": [],
  "using_namespace": "clanguml::t00055"
}
```
