# t20003 - Function template sequence diagram test case
## Config
```yaml
compilation_database_dir: ..
output_directory: diagrams
diagrams:
  t20003_sequence:
    type: sequence
    glob:
      - ../../tests/t20003/t20003.cc
    include:
      namespaces:
        - clanguml::t20003
    using_namespace:
      - clanguml::t20003
    from:
      - function: "clanguml::t20003::m1<T>(T)"

```
## Source code
File t20003.cc
```cpp
namespace clanguml {
namespace t20003 {

template <typename T> void m4(T p) { }

template <typename T> void m3(T p) { m4<T>(p); }

template <typename T> void m2(T p) { m3<T>(p); }

template <typename T> void m1(T p) { m2<T>(p); }
}
}

```
## Generated PlantUML diagrams
![t20003_sequence](./t20003_sequence.svg "Function template sequence diagram test case")
## Generated Mermaid diagrams
![t20003_sequence](./t20003_sequence_mermaid.svg "Function template sequence diagram test case")
## Generated JSON models
```json
{
  "diagram_type": "sequence",
  "metadata": {
    "clang_uml_version": "0.4.1-11-g39d3e1f",
    "llvm_version": "Ubuntu clang version 16.0.6 (++20230710042027+7cbf1a259152-1~exp1~20230710162048.105)",
    "schema_version": 1
  },
  "name": "t20003_sequence",
  "participants": [
    {
      "id": "469205740799240869",
      "name": "clanguml::t20003::m1<T>(T)",
      "source_location": {
        "column": 28,
        "file": "../../tests/t20003/t20003.cc",
        "line": 10,
        "translation_unit": "../../tests/t20003/t20003.cc"
      },
      "type": "function_template"
    },
    {
      "id": "1502957449367040488",
      "name": "clanguml::t20003::m2<T>(T)",
      "source_location": {
        "column": 28,
        "file": "../../tests/t20003/t20003.cc",
        "line": 8,
        "translation_unit": "../../tests/t20003/t20003.cc"
      },
      "type": "function_template"
    },
    {
      "id": "613477682313507585",
      "name": "clanguml::t20003::m3<T>(T)",
      "source_location": {
        "column": 28,
        "file": "../../tests/t20003/t20003.cc",
        "line": 6,
        "translation_unit": "../../tests/t20003/t20003.cc"
      },
      "type": "function_template"
    },
    {
      "id": "619960023608507925",
      "name": "clanguml::t20003::m4<T>(T)",
      "source_location": {
        "column": 28,
        "file": "../../tests/t20003/t20003.cc",
        "line": 4,
        "translation_unit": "../../tests/t20003/t20003.cc"
      },
      "type": "function_template"
    }
  ],
  "sequences": [
    {
      "messages": [
        {
          "from": {
            "activity_id": "469205740799240869",
            "activity_name": "clanguml::t20003::m1<T>(T)",
            "participant_id": "469205740799240869",
            "participant_name": "clanguml::t20003::m1<T>(T)"
          },
          "name": "",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 38,
            "file": "../../tests/t20003/t20003.cc",
            "line": 10,
            "translation_unit": "../../tests/t20003/t20003.cc"
          },
          "to": {
            "activity_id": "1502957449367040488",
            "activity_name": "clanguml::t20003::m2<T>(T)",
            "participant_id": "1502957449367040488"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "1502957449367040488",
            "activity_name": "clanguml::t20003::m2<T>(T)",
            "participant_id": "1502957449367040488",
            "participant_name": "clanguml::t20003::m2<T>(T)"
          },
          "name": "",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 38,
            "file": "../../tests/t20003/t20003.cc",
            "line": 8,
            "translation_unit": "../../tests/t20003/t20003.cc"
          },
          "to": {
            "activity_id": "613477682313507585",
            "activity_name": "clanguml::t20003::m3<T>(T)",
            "participant_id": "613477682313507585"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "613477682313507585",
            "activity_name": "clanguml::t20003::m3<T>(T)",
            "participant_id": "613477682313507585",
            "participant_name": "clanguml::t20003::m3<T>(T)"
          },
          "name": "",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 38,
            "file": "../../tests/t20003/t20003.cc",
            "line": 6,
            "translation_unit": "../../tests/t20003/t20003.cc"
          },
          "to": {
            "activity_id": "619960023608507925",
            "activity_name": "clanguml::t20003::m4<T>(T)",
            "participant_id": "619960023608507925"
          },
          "type": "message"
        }
      ],
      "start_from": {
        "id": 469205740799240869,
        "location": "clanguml::t20003::m1<T>(T)"
      }
    }
  ],
  "using_namespace": "clanguml::t20003"
}
```
