# t20005 - Class template basic sequence diagram
## Config
```yaml
compilation_database_dir: ..
output_directory: diagrams
diagrams:
  t20005_sequence:
    type: sequence
    glob:
      - ../../tests/t20005/t20005.cc
    include:
      namespaces:
        - clanguml::t20005
    using_namespace:
      - clanguml::t20005
    from:
      - function: "clanguml::t20005::C<T>::c(T)"
```
## Source code
File t20005.cc
```cpp
namespace clanguml {
namespace t20005 {

template <typename T> struct A {
    T a(T arg) { return arg; }
};

template <typename T> struct B {
    T b(T arg) { return a_.a(arg); }

    A<T> a_;
};

template <typename T> struct C {
    T c(T arg) { return b_.b(arg); }

    B<T> b_;
};

}
}
```
## Generated PlantUML diagrams
![t20005_sequence](./t20005_sequence.svg "Class template basic sequence diagram")
## Generated Mermaid diagrams
![t20005_sequence](./t20005_sequence_mermaid.svg "Class template basic sequence diagram")
## Generated JSON models
```json
{
  "diagram_type": "sequence",
  "metadata": {
    "clang_uml_version": "0.4.1-11-g39d3e1f",
    "llvm_version": "Ubuntu clang version 16.0.6 (++20230710042027+7cbf1a259152-1~exp1~20230710162048.105)",
    "schema_version": 1
  },
  "name": "t20005_sequence",
  "participants": [
    {
      "id": "365569130532127604",
      "name": "clanguml::t20005::C<T>",
      "source_location": {
        "column": 30,
        "file": "../../tests/t20005/t20005.cc",
        "line": 14,
        "translation_unit": "../../tests/t20005/t20005.cc"
      },
      "type": "class"
    },
    {
      "id": "666000829532846850",
      "name": "clanguml::t20005::B<T>",
      "source_location": {
        "column": 30,
        "file": "../../tests/t20005/t20005.cc",
        "line": 8,
        "translation_unit": "../../tests/t20005/t20005.cc"
      },
      "type": "class"
    },
    {
      "id": "1278330455625941185",
      "name": "clanguml::t20005::A<T>",
      "source_location": {
        "column": 30,
        "file": "../../tests/t20005/t20005.cc",
        "line": 4,
        "translation_unit": "../../tests/t20005/t20005.cc"
      },
      "type": "class"
    }
  ],
  "sequences": [
    {
      "messages": [
        {
          "from": {
            "activity_id": "578718872965404973",
            "activity_name": "clanguml::t20005::C<T>::c(T)",
            "participant_id": "365569130532127604"
          },
          "name": "b(T)",
          "return_type": "T",
          "scope": "normal",
          "source_location": {
            "column": 25,
            "file": "../../tests/t20005/t20005.cc",
            "line": 15,
            "translation_unit": "../../tests/t20005/t20005.cc"
          },
          "to": {
            "activity_id": "870466496899932117",
            "activity_name": "clanguml::t20005::B<T>::b(T)",
            "participant_id": "666000829532846850"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "870466496899932117",
            "activity_name": "clanguml::t20005::B<T>::b(T)",
            "participant_id": "666000829532846850"
          },
          "name": "a(T)",
          "return_type": "T",
          "scope": "normal",
          "source_location": {
            "column": 25,
            "file": "../../tests/t20005/t20005.cc",
            "line": 9,
            "translation_unit": "../../tests/t20005/t20005.cc"
          },
          "to": {
            "activity_id": "124853455814403745",
            "activity_name": "clanguml::t20005::A<T>::a(T)",
            "participant_id": "1278330455625941185"
          },
          "type": "message"
        }
      ],
      "return_type": "T",
      "start_from": {
        "id": 578718872965404973,
        "location": "clanguml::t20005::C<T>::c(T)"
      }
    }
  ],
  "using_namespace": "clanguml::t20005"
}
```
